#region Using declarations
using System;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.ComponentModel;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// Enter the description of your new custom indicator here
    /// </summary>
    [Description("Enter the description of your new custom indicator here")]
    [Gui.Design.DisplayName("ZeroLagStochs")]
    public class ZeroLagStochs : Indicator
    {
        #region Variables
        // Wizard generated variables
        // User defined variables (add any user defined variables below)
		
		
		
		private double stok1=0,stok2=0,stok3=0,stok4=0,stok5=0,mov=0,stoksmoothed=0,smoothing=15;
		private int shift=0, MAType=1, cnt=0,  prevbars=0,loopbegin=0;

		private bool old = true;
        #endregion

        /// <summary>
        /// This method is used to configure the indicator and is called once before any bar data is loaded.
        /// </summary>
        protected override void Initialize()
        {
            Add(new Plot(Color.FromKnownColor(KnownColor.Red), PlotStyle.Line, "Mov"));
            Add(new Plot(Color.FromKnownColor(KnownColor.Green), PlotStyle.Line, "Smoothed"));
            CalculateOnBarClose	= true;
            Overlay				= false;
            PriceTypeSupported	= false;
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
            // Use this method for calculating your indicator values. Assign a value to each
            // plot below by replacing 'Close[0]' with your own formula.
			//if( !old )
			//{
				shift = 0;
				stok1 = IStochastics(3,8,3)[shift]*0.05;
				stok2 = 	IStochastics(21,89,3)[shift]*0.43;
				stok3 = IStochastics(13,55,3)[shift]*0.26;
				stok4 = IStochastics(8,34,3)[shift]*0.16;
				stok5 = IStochastics(5,21,3)[shift]*0.10;
				mov   = stok1+stok2+stok3+stok4+stok5;
					
				double val = CurrentBar == 0 ? 0 : Smoothed[shift+1];
				stoksmoothed = mov/smoothing + val *(smoothing-1)/smoothing;
				Mov.Set(mov);
				Smoothed.Set(stoksmoothed);
			/*}
			else
			{
				if ( CurrentBar < 5 )
					return;
		
				loopbegin = loopbegin+1; 
		
				for (shift = loopbegin; shift>= 0 ;shift--)
				{

					stok1 = IStochastics(3,8,3)[shift]*0.05;
					stok2 = 	IStochastics(21,89,3)[shift]*0.43;
					stok3 = IStochastics(13,55,3)[shift]*0.26;
					stok4 = IStochastics(8,34,3)[shift]*0.16;
					stok5 = IStochastics(5,21,3)[shift]*0.10;
					mov   = stok1+stok2+stok3+stok4+stok5;
					stoksmoothed = mov/smoothing + Smoothed[shift+1]*(smoothing-1)/smoothing;
					Mov.Set(mov);
					Smoothed.Set(stoksmoothed);
		
					loopbegin = loopbegin-1;     
				
				}
			}*/
		}

        #region Properties
        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Mov
        {
            get { return Values[0]; }
        }

        [Browsable(false)]	// this line prevents the data series from being displayed in the indicator properties dialog, do not remove
        [XmlIgnore()]		// this line ensures that the indicator can be saved/recovered as part of a chart template, do not remove
        public DataSeries Smoothed
        {
            get { return Values[1]; }
        }

        #endregion
    }
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ZeroLagStochs[] cacheZeroLagStochs = null;

        private static ZeroLagStochs checkZeroLagStochs = new ZeroLagStochs();

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ZeroLagStochs ZeroLagStochs()
        {
            return ZeroLagStochs(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public ZeroLagStochs ZeroLagStochs(Data.IDataSeries input)
        {

            if (cacheZeroLagStochs != null)
                for (int idx = 0; idx < cacheZeroLagStochs.Length; idx++)
                    if (cacheZeroLagStochs[idx].EqualsInput(input))
                        return cacheZeroLagStochs[idx];

            ZeroLagStochs indicator = new ZeroLagStochs();
            indicator.BarsRequired = BarsRequired;
            indicator.CalculateOnBarClose = CalculateOnBarClose;
            indicator.Input = input;
            indicator.SetUp();

            ZeroLagStochs[] tmp = new ZeroLagStochs[cacheZeroLagStochs == null ? 1 : cacheZeroLagStochs.Length + 1];
            if (cacheZeroLagStochs != null)
                cacheZeroLagStochs.CopyTo(tmp, 0);
            tmp[tmp.Length - 1] = indicator;
            cacheZeroLagStochs = tmp;
            Indicators.Add(indicator);

            return indicator;
        }

    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ZeroLagStochs ZeroLagStochs()
        {
            return _indicator.ZeroLagStochs(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ZeroLagStochs ZeroLagStochs(Data.IDataSeries input)
        {
            return _indicator.ZeroLagStochs(input);
        }

    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ZeroLagStochs ZeroLagStochs()
        {
            return _indicator.ZeroLagStochs(Input);
        }

        /// <summary>
        /// Enter the description of your new custom indicator here
        /// </summary>
        /// <returns></returns>
        public Indicator.ZeroLagStochs ZeroLagStochs(Data.IDataSeries input)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ZeroLagStochs(input);
        }

    }
}
#endregion
